module Engine.ExperimentResult
( ExperimentResult(..)
, RanExperiment(..)
, remapExperimentResult
, experimentRTValue
) where

import Bottom
import Control.Exception
import Data.Map (Map)
import Data.Maybe
import Data.Sequence (Seq)
import Plan
import qualified Data.Map as Map
import Engine.EngineHValue

data ExperimentResult 
  = Redundant !(Seq Experiment)
  | Ok 
  | Errors !SomeException
  | Bottoms !BottomId
  | Property !Bool

data RanExperiment
  = NewResult     { getExperimentResult :: !ExperimentResult
                  , _experimentRTValue   :: !(Maybe EngineHValue) 
                  }
  | CachedResult  { getExperimentResult :: !ExperimentResult }

experimentRTValue :: RanExperiment -> Maybe EngineHValue
experimentRTValue (NewResult _ v) = v
experimentRTValue (CachedResult _) = Nothing

remapExperimentResult :: Map BottomId BottomId -> ExperimentResult ->  ExperimentResult
remapExperimentResult mp (Bottoms bid) = Bottoms . fromMaybe (error "remapExperimentResult - E") . Map.lookup bid $ mp
remapExperimentResult _ er = er
